----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity SinusCounter is
    Generic( N: natural := 27);
    Port ( Clk :    in    STD_LOGIC;
	        Test:    in    STD_LOGIC;  
           Adr :    out   STD_LOGIC_VECTOR (5 downto 0));
end SinusCounter;

architecture Behavioral of SinusCounter is
   Signal Counter: STD_LOGIC_VECTOR (N downto 0) := (others => '0');
begin

   Adr <= Counter(8 downto 3) when Test='1' else
	       Counter(N downto N-5);
			 
   process( Clk)
	begin
	   if rising_edge( Clk) then
         Counter <= Counter+1;
		end if;
	end process;
end Behavioral;

